/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.reporting;

import java.io.File;
import java.util.ArrayList;

public class FileCollector {
    String directory = null;
    String filenamesStartWith = null;
    String filenamesEndWith = null;
    
    ArrayList<File> files = new ArrayList<File>();
    
    public FileCollector(String directory, String filenamesStartWith, String filenamesEndWith) {
        super();
        this.directory = directory;
        this.filenamesStartWith = filenamesStartWith;
        this.filenamesEndWith = filenamesEndWith;
    }

    public ArrayList<File> collect()
    {
        File f = new File(this.directory);
        scan (f,false);
        return files;
    }
    
    private void scan(File f, boolean delete)
    {
//        System.out.println(f.getAbsolutePath());
        if(f.isDirectory())
        {
            if (f.getName().contains(".skip")) {
                return;
            }
            File[] files = f.listFiles();
            for (int i = 0; i < files.length; i++) {
                scan (files[i], delete);
            }
        }
        if (f.getName().startsWith(this.filenamesStartWith)
                && f.getName().endsWith(this.filenamesEndWith)) 
        {
            if (delete) {
                f.delete();
                System.out.println("file delete:" + f.getAbsolutePath());                
            } else {
                System.out.println("file add:" + f.getAbsolutePath());
                this.files.add(f);
            }
        }
        
    }

    public void delete() {
        File f = new File(this.directory);
        scan (f,true);
        
    }
    

}
