/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.reporting;

import java.text.DecimalFormat;
import java.text.ParseException;
import java.util.GregorianCalendar;

import javax.swing.text.NumberFormatter;

public class Timestamp {
    String stringRep;
    String day;
    String month;
    String year;
    String hour;
    String min;
    String sec;
    GregorianCalendar cal;
    
    public Timestamp(String stringRep) {
        super();
        this.stringRep = stringRep;
        day = stringRep.substring(8,9+1);
        month = stringRep.substring(5,6+1);
        year = stringRep.substring(0,3+1);
        hour = stringRep.substring(11,12+1);
        min = stringRep.substring(14,15+1);
        sec = stringRep.substring(17,18+1);
        cal = new GregorianCalendar();
        cal.set(GregorianCalendar.DATE, Integer.parseInt(day));
        cal.set(GregorianCalendar.MONTH, Integer.parseInt(month)-1);
        cal.set(GregorianCalendar.YEAR, Integer.parseInt(year));
        cal.set(GregorianCalendar.HOUR_OF_DAY, Integer.parseInt(hour));
        cal.set(GregorianCalendar.MINUTE, Integer.parseInt(min));
        cal.set(GregorianCalendar.SECOND, Integer.parseInt(sec));

    }
    
    public Timestamp(GregorianCalendar cal) {
        super();
        this.cal = cal;
        
    }

    public GregorianCalendar asInternal()
    {
        return cal;
    }
    
    public String forFilenames () throws ParseException
    {
        String timestamp;
        NumberFormatter formatter = new NumberFormatter();
        formatter.setFormat(new DecimalFormat("00"));
        timestamp = Integer.toString(cal.get(GregorianCalendar.YEAR));
        timestamp += "-" + formatter.valueToString(cal.get(GregorianCalendar.MONTH)+1);
        timestamp += "-" + formatter.valueToString(cal.get(GregorianCalendar.DAY_OF_MONTH));
        timestamp += "T" + formatter.valueToString(cal.get(GregorianCalendar.HOUR_OF_DAY));
        timestamp += "-" + formatter.valueToString(cal.get(GregorianCalendar.MINUTE));
        return timestamp;
    }
    
    
    
}
