/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
/*******************************************************************
*  PRVDLG.HXX
*  (c) 1992-1994 STAR DIVISION
*******************************************************************/

// --- class PreviewBox --------------------------------------------

class PreviewBox : public Control
{
public:
    PreviewBox( Window* pParent, const ResId& rResId );
};

// --- class PreviewDialog -----------------------------------------

class PreviewDialog : public ModalDialog
{
private:
    PreviewBox      aPVBox;
    ScrollBar       aVScroll;
    ScrollBar       aHScroll;
    PushButton      aZoomIn;
    PushButton      aZoomOut;
    PushButton      aNormalPage;
    PushButton      aFullPage;
    PushButton      aDoublePage;
    PushButton      aPrevPage;
    PushButton      aNextPage;
    CancelButton    aCancel;

    USHORT          nPage;
    Fraction        aZoom;
    Point           aOffset;
    Size            aMaxSize;
    Link            aRequestPageHdl;
    Preview*        pPreview;
    Preview*        pSecondPreview;
    JobSetup*       pSetup;

    Size            CalcPreviewSize();
    void            CheckScrollRange();

public:
                    PreviewDialog( Window* pParent,
                                   JobSetup* pSetup );
                    ~PreviewDialog();

    Link            ChangeRequestPageHdl( const Link& rLink );

    void            VScrollEndHdl( ScrollBar* pScrollBar );
    void            HScrollEndHdl( ScrollBar* pScrollBar );
    void            ZoomInHdl( Button* );
    void            ZoomOutHdl( Button* );
    void            NormalPageHdl( Button* );
    void            FullPageHdl( Button* );
    void            DoublePageHdl( Button* );
    void            PrevPageHdl( Button* );
    void            NextPageHdl( Button* );

    void            PrintPage( Preview* );
};
