/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
// sosappl.h                                  1996 SOS GmbH Berlin

#ifndef __SOSAPPL_H
#define __SOSAPPL_H

#ifndef __SOSSTAT_H
#   include "sosstat.h"
#endif

namespace sos
{

struct Sos_appl
{
                                Sos_appl            ( Bool init = true );  // bei false: init() selbst aufrufen!
                               ~Sos_appl            ();

    void                        init                ();
    void                        exit                ();

    Bool                       _valid; 
};


inline void Sos_appl::init()
{
    //jz 5.8.97 sos_static_ptr()->init();
    sos_static_ptr()->add_ref();
    _valid = true;
}


inline void Sos_appl::exit()
{
    if( _valid ) {
        sos_static_ptr()->remove_ref();
        _valid = false;
    }
}


inline Sos_appl::Sos_appl( Bool ini )
:
    _valid ( false )
{
    if( ini )  init();
}


inline Sos_appl::~Sos_appl()
{
    exit();
}


} //namespace sos


#endif

