/********************************************************* begin of preamble
**
** Copyright (C) 2003-2010 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
#ifndef __VIDEOWIN_H
#define __VIDEOWIN_H

#include <sv.hxx>
#undef min
#undef max

#include <video.h>



const unsigned short _LineOffset = 2;

class VideoWin : public WorkWindow,
                 public Video
{
public:
    VideoWin() :
       WorkWindow( NULL, WB_APP | WB_STDWORK ) {
        _init(); 
    };

    VideoWin( Window* pParent, WinBits nWinStyle ) :
       WorkWindow( pParent, nWinStyle ) {
       _init();
    };

    virtual void Paint( const Rectangle& );

    virtual void write( Video_pos pos, char c, Video_attr );
    virtual void write( Video_pos pos, char *text, int len, Video_attr );
    

    virtual void move(
      Subrange< int, 0, video_line_count >,
      Subrange< int, 0, video_line_count >,
      Subrange< int, 0, video_line_count > );

    void ScrollUpLine( Subrange< int, 0, video_line_count > = 1 );


    char aVideoBuffer[video_line_length * video_line_count + 1];
 
    Size FontSize() { return aFontSize; };

    void ChangeCharSet( FontCharSet fcs ) {
       Font f = GetFont();
       f.ChangeCharSet( fcs );
       ChangeFont( f );
    };
    void sync();

private:
    void _init();
    Size aFontSize;
    Size aScreenSize;
};

inline void Video_window::sync()
{
    Show();
    Invalidate(); //Paint( Rectangle(0,0,0,0) );
}

#endif
